=== debian/changelog ===
enamelpin-by-suricrasiaonline (1.0+git20200705-0ddebs1~ubuntu24.04) noble; urgency=medium

  * Initial release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Thu, 08 May 2025 17:34:52 +0200
