=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,pretty=1.0+git%cd, \
         repack,compression=xz" \
         https://github.com/Suricrasia-Online/Enamel-Pin \
         HEAD debian uupdate
